#!/usr/bin/perl
use strict;
use warnings;
use SOAP::Lite;


#/**************** Settings begin **************/
my $username  = ''; # Enter your Interfax username here
my $password  = ''; # Enter your Interfax password here
# Enter the destination fax number here in the format:
# +[country code][area code][fax number] for example: +1212555487
my $faxNumber = ''; 
my $textToFax  = 'My text goes here';
# If $textToFax holds regular text, enter "TXT" here.
# If $textToFax holds HTML enter "HTML" here 
my $filetype  = 'TXT';
my $NS = 'http://www.interfax.cc';
#/**************** Settings end ****************/


my $client = SOAP::Lite
	->uri($NS)
	->on_action( sub { join '/', $NS, $_[1] } ) 
	->proxy('https://ws.interfax.net/dfs.asmx?wsdl');

my $result = $client
	->call(SOAP::Data->name('SendCharFax')->attr({xmlns => $NS}) =>
                    SOAP::Data->name('Username')->value($username)->type(''),
		    SOAP::Data->name('Password')->value($password)->type(''),
		    SOAP::Data->name('FaxNumber')->value($faxNumber)->type(''),
		    SOAP::Data->name('Data')->value($textToFax)->type(''),
		    SOAP::Data->name('FileType')->value($filetype)->type('')
	);


if ( $result->fault ) {
    print $result->faultstring . "\n";
} else {
	if( $result->valueof('//SendCharFaxResult') > 0 ) {
		print "Success. TransactionID=" . $result->valueof('//SendCharFaxResult') . "\n";
	} else {
		print "Error, return code=" . $result->valueof('//SendCharFaxResult') . "\n";
	}
}