#!/usr/bin/perl
use strict;
use warnings;
use SOAP::Lite;


#/**************** Settings begin **************/
my $username  = ''; # Enter your Interfax username here
my $password  = ''; # Enter your Interfax password here
my $transactionID = "";
my $NS = 'http://www.interfax.cc';
#/**************** Settings end ****************/


my $client = SOAP::Lite
	->uri($NS)
	->on_action( sub { join '/', $NS, $_[1] } ) 
	->proxy('http://ws.interfax.net/dfs.asmx?WSDL');
	
my $result = $client
	->call(SOAP::Data->name('CancelFax')->attr({xmlns => $NS}) =>
			SOAP::Data->name('Username')->value($username)->type(''),
		    SOAP::Data->name('Password')->value($password)->type(''),
		    SOAP::Data->name('TransactionID')->value($transactionID)->type('')
	);


if ( $result->fault ) {
    print $result->faultstring . "\n";
} else {
	if( $result->valueof('//CancelFaxResult') == 0 ) {
		print "Success" . "\n";
	} else {
		print "Error, return code=" . $result->valueof('//CancelFaxResult') . "\n";
	}
}
